
#property copyright "Copyright  2008 BabaMaster"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Fuchsia
#property indicator_color2 Lime
#property indicator_color3 Green
#property indicator_color4 Red

double SlopeBuff[];
double SLSMABuff[];
extern double Smooth_Ratio = 0.5;
extern int    Rperiod      = 34;
extern int    Draw4HowLong = 1000;
double gwd3 = 0.0;
int i;
int j;
int BLimit;
double WorkBuff4[];
int IndPer;
double gwd1;
double gwd2;
double WorkBuff5[];
double WorkBuff6[];
double WorkBuff7[];
double Signal_Up[];
double Signal_Dn[];

int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0, SLSMABuff);
   SetIndexBuffer(1, SlopeBuff);
   SetIndexBuffer(2, Signal_Up);
   SetIndexBuffer(3, Signal_Dn);
   SetIndexBuffer(4, WorkBuff4);
   SetIndexBuffer(5, WorkBuff5);
   SetIndexBuffer(6, WorkBuff6);
   SetIndexBuffer(7, WorkBuff7);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(2, DRAW_ARROW, EMPTY);
   SetIndexStyle(3, DRAW_ARROW, EMPTY);
   SetIndexArrow(2, 159);
   SetIndexArrow(3, 159);
   string IndShName = "SLSMA v1.0";
   IndicatorShortName(IndShName);
   SetIndexLabel(0, "SLSMA ");
   SetIndexLabel(1, "SLSMA slope");
   SetIndexLabel(2, "SLSMA Signal up");
   SetIndexLabel(3, "SLSMA Signal down");
   return (0);
}

int start() {
   double Loc01;
   double Loc02;
   double Loc03;
   double Loc04;
   double LArr01[5];
   double LArr02[8];
   double LArr03[8];
   double LArr04[8];
   double LArr05[8];
   double LArr06[3];
   double LArr07[3];
   double LArr08[3];
   double LArr09[3];
   double LArr10[3];
   double LArr11[3];
   double LArr12[3];
   double LArr13[3];
   double LArr14[3];
   string TLim = "2029.01.01";
   int TLimTime = StrToTime(TLim);
   if (TimeCurrent() >= TLimTime) {
      Alert("This version has been expired! Please look for update");
      return (0);
   }
   IndPer = Rperiod;
   BLimit = Draw4HowLong - IndPer - 1;
   for (i = BLimit; i >= 0; i--) {
      WorkBuff4[1] = 0;
      for (j = IndPer; j >= 1; j--) {
         gwd1 = IndPer + 1;
         gwd1 /= 3.0;
         gwd2 = 0;
         gwd2 = (j - gwd1) * (Close[IndPer - j + i]);
         WorkBuff4[1] += gwd2;
      }
      WorkBuff5[i] = 6.0 * WorkBuff4[1] / (IndPer * (IndPer + 1));
   }
   int CountedBars = IndicatorCounted();
   if (Bars <= 5) return (0);
   for (int k = Bars - CountedBars + 50; k >= 0; k--) {
      LArr01[1] = WorkBuff5[k];
      LArr01[2] = WorkBuff5[k + 1];
      LArr01[3] = WorkBuff5[k + 2];
      LArr01[4] = WorkBuff5[k + 3];
      LArr02[1] = (4.0 * LArr01[1] + 3.0 * LArr01[2] + 2.0 * LArr01[3] + LArr01[4]) / 10.0;
      LArr03[1] = (LArr02[1] / 10.0 + 0.5769 * LArr02[3] - 0.5769 * LArr02[5] - LArr02[7] / 10.0) * (0.075 * LArr11[2] + 0.54);
      LArr04[1] = (LArr03[1] / 10.0 + 0.5769 * LArr03[3] - 0.5769 * LArr03[5] - LArr03[7] / 10.0) * (0.075 * LArr11[2] + 0.54);
      LArr05[1] = LArr03[4];
      Loc01 = (LArr05[1] / 10.0 + 0.5769 * LArr05[3] - 0.5769 * LArr05[5] - LArr05[7] / 10.0) * (0.075 * LArr11[2] + 0.54);
      Loc02 = (LArr04[1] / 10.0 + 0.5769 * LArr04[3] - 0.5769 * LArr04[5] - LArr04[7] / 10.0) * (0.075 * LArr11[2] + 0.54);
      LArr06[1] = LArr05[1] - Loc02;
      LArr07[1] = LArr04[1] + Loc01;
      LArr06[1] = 0.2 * LArr06[1] + 0.8 * LArr06[2];
      LArr07[1] = 0.2 * LArr07[1] + 0.8 * LArr07[2];
      LArr08[1] = LArr06[1] * LArr06[2] + LArr07[1] * LArr07[2];
      LArr09[1] = LArr06[1] * LArr07[2] - LArr07[1] * LArr06[2];
      LArr08[1] = 0.2 * LArr08[1] + 0.8 * LArr08[2];
      LArr09[1] = 0.2 * LArr09[1] + 0.8 * LArr09[2];
      if (LArr09[1] != 0.0 && LArr08[1] != 0.0) LArr11[1] = 360 / MathArctan(LArr09[1] / LArr08[1]);
      if (LArr11[1] > 1.5 * LArr11[2]) LArr11[1] = 1.5 * LArr11[2];
      if (LArr11[1] < 0.67 * LArr11[2]) LArr11[1] = 0.67 * LArr11[2];
      if (LArr11[1] < 6.0) LArr11[1] = 6;
      if (LArr11[1] > 50.0) LArr11[1] = 50;
      LArr11[1] = 0.2 * LArr11[1] + 0.8 * LArr11[2];
      LArr10[1] = 0.33 * LArr11[1] + 0.67 * LArr10[2];
      if (LArr05[1] != 0.0) LArr12[1] = MathArctan(LArr04[1] / LArr05[1]);
      Loc03 = LArr12[2] - LArr12[1];
      if (Loc03 < 1.0) Loc03 = 1;
      Loc04 = Smooth_Ratio / Loc03;
      if (Loc04 < gwd3) Loc04 = gwd3;
      LArr13[1] = Loc04 * LArr01[1] + (1 - Loc04) * LArr13[2];
      LArr14[1] = Loc04 / 2.0 * LArr13[1] + (1 - Loc04 / 2.0) * LArr14[2];
      WorkBuff6[k] = LArr13[1];
      WorkBuff7[k] = LArr14[1];
      SlopeBuff[k] = WorkBuff6[k];
      SLSMABuff[k] = WorkBuff6[k];
      if (WorkBuff6[k] < WorkBuff6[k + 1]) SlopeBuff[k] = EMPTY_VALUE;
      if (WorkBuff6[k] > WorkBuff6[k + 1]) SlopeBuff[k + 1] = WorkBuff6[k + 1];
      if (WorkBuff6[k + 1] < WorkBuff7[k + 1] && WorkBuff6[k] > WorkBuff7[k]) Signal_Up[k] = WorkBuff6[k] - 20.0 * Point;
      if (WorkBuff6[k + 1] > WorkBuff7[k + 1] && WorkBuff6[k] < WorkBuff7[k]) Signal_Dn[k] = WorkBuff6[k] + 20.0 * Point;
      LArr02[7] = LArr02[5];
      LArr02[6] = LArr02[5];
      LArr02[5] = LArr02[4];
      LArr02[4] = LArr02[3];
      LArr02[3] = LArr02[2];
      LArr02[2] = LArr02[1];
      LArr03[7] = LArr03[6];
      LArr03[6] = LArr03[5];
      LArr03[5] = LArr03[4];
      LArr03[4] = LArr03[3];
      LArr03[3] = LArr03[2];
      LArr03[2] = LArr03[1];
      LArr04[7] = LArr04[6];
      LArr04[6] = LArr04[5];
      LArr04[5] = LArr04[4];
      LArr04[4] = LArr04[3];
      LArr04[3] = LArr04[2];
      LArr04[2] = LArr04[1];
      LArr05[7] = LArr05[6];
      LArr05[6] = LArr05[5];
      LArr05[5] = LArr05[4];
      LArr05[4] = LArr05[3];
      LArr05[3] = LArr05[2];
      LArr05[2] = LArr05[1];
      LArr07[2] = LArr07[1];
      LArr06[2] = LArr06[1];
      LArr08[2] = LArr08[1];
      LArr09[2] = LArr09[1];
      LArr10[2] = LArr10[1];
      LArr12[2] = LArr12[1];
      LArr11[2] = LArr11[1];
      LArr13[2] = LArr13[1];
      LArr14[2] = LArr14[1];
   }
   return (0);
}